//+------------------------------------------------------------------+
//|                                           MTF Moving Average.mq4 |
//+------------------------------------------------------------------+

// trading rules:
   // trading TimeFrame: 1H
   // MTF: 30M - (1H)  - 4H
   


extern bool enableSTDcheck= true; 

extern int sMultiple = 4;   //<---- changed setting 
extern int fMultiple = 4;   //<---- same as above  
extern double risk = 0.3;     
extern double reward = 1.2;     //<---- 
extern int Stack = 5;       //<---- new
extern int DistanceApart = 5;   //<---- new


//extern double lowerTimeFrame = 30;
extern double tradingTimeFrame=60;
//extern double higherTImeFrame= 240

extern int entryTF=15;

//<--- trading hours variables 
extern bool AllowTradingHours = true;

extern int     OpenHour=11;  
extern int     CloseHour=17;

extern double lots=0.02;

extern int slowMovingPeriod = 25; //<---50 changed
extern int fastMovingPeriod = 150; //<---100; changed

int maxSlowTrades = 1;
bool reverseTrades = false;

double price = 0;   //<---- added
double tp = 0;
double sl = 0;
double bid = 0;
double ask = 0;
double digits = 0;
double point = 0;
int type = 0;        //<---- added


int slowMagicNumber = 09062011;
//int fastMagicNumber = 09072011;

double slowMA1, slowMA5, slowMA15, slowMA30, slowMA60, slowMA240, slowMA1440, slowMA10080;
double fastMA1, fastMA5, fastMA15, fastMA30, fastMA60, fastMA240, fastMA1440;

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
void checkConditions()
{
// slow  
   slowMA1=iMA(NULL,1,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);  
   slowMA5=iMA(NULL,5,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);
   slowMA15=iMA(NULL,15,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);
   slowMA30=iMA(NULL,30,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);
   slowMA60=iMA(NULL,60,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);   
   slowMA240=iMA(NULL,240,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);
   slowMA1440=iMA(NULL,1440,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);
   slowMA10080=iMA(NULL,10080,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);
   
   // fast
   fastMA1=iMA(NULL,1,fastMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);
   fastMA5=iMA(NULL,5,fastMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);
   fastMA15=iMA(NULL,15,fastMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);
   fastMA30=iMA(NULL,30,fastMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);
   fastMA60=iMA(NULL,60,fastMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);
   fastMA240=iMA(NULL,240,fastMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);
   fastMA1440=iMA(NULL,1440,fastMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0);
   
   if(enableSTDcheck==true)   //<---- moved into checkconditions not sure why here?
   {
      checkSTD();
   }     

   if((Close[0]<=fastMA30 && Close[0]<=fastMA60 && Close[0]<=fastMA240))
   {
      // we are in a downtrend
      if(!reverseTrades)
         shortEntry();
      else
         longEntry();
   }  
   else if((Close[0]>=fastMA30 && Close[0]>=fastMA60 && Close[0]>=fastMA240))
   {
      // we are in a uptrend
      if(!reverseTrades)
         longEntry();
      else
         shortEntry();   
      
   }
   else
   {
      // neither up or down trend
      Comment("\n"+"no direction");
   }
}

void checkSTD()
{
   
   //for(int e=7;e<=7;e++) // 7 MA(s)
   //{
      double std2M1=(2)*(iStdDev(NULL,1,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0));
      if(MathAbs(Close[0]-slowMA1)>std2M1)
      {
         Comment("\n"+"1M Close is 2 standard deviaions away from MA:"+slowMovingPeriod);
      }
      
      double std2M5=(2)*(iStdDev(NULL,5,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0));
      if(MathAbs(Close[0]-slowMA5)>std2M5)
      {
         Comment("\n"+"5M Close is 2 standard deviaions away from MA:"+slowMovingPeriod);
      }
      
      double std2M15=(2)*(iStdDev(NULL,15,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0));
      if(MathAbs(Close[0]-slowMA15)>std2M15)
      {
         Comment("\n"+"15M Close is 2 standard deviaions away from MA:"+slowMovingPeriod);
      }
      
      double std2M30=(2)*(iStdDev(NULL,30,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0));
      if(MathAbs(Close[0]-slowMA30)>std2M30)
      {
         reverseTrades = true;
         Comment("\n"+"30M Close is 2 standard deviaions away from MA:"+slowMovingPeriod);
      }
      
      double std2H1=(2)*(iStdDev(NULL,60,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0));
      if(MathAbs(Close[0]-slowMA60)>std2H1)
      {
         Comment("\n"+"1H Close is 2 standard deviaions away from MA:"+slowMovingPeriod);
         reverseTrades = true;
      }
      
      double std2H4=(2)*(iStdDev(NULL,240,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0));
      if(MathAbs(Close[0]-slowMA240)>std2H4)
      {
         Comment("\n"+"4H Close is 2 standard deviaions away from MA:"+slowMovingPeriod);
      }
      
      double std2D1=(2)*(iStdDev(NULL,1440,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0));
      if(MathAbs(Close[0]-slowMA1440)>std2D1)
      {
         Comment("\n"+"1D Close is 2 standard deviaions away from MA:"+slowMovingPeriod);
      }
      
      double std2W1=(2)*(iStdDev(NULL,10080,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0));
      if(MathAbs(Close[0]-slowMA10080)>std2W1)
      {
         Comment("\n"+"1W Close is 2 standard deviaions away from MA:"+slowMovingPeriod);
      }
      
   //}
}

void checkExposure()
{
   int ordTotal = OrdersTotal();
   double pipExposure=0;

   for (int i=0;i<=ordTotal;i++)
      {      
         OrderSelect(i, SELECT_BY_POS, MODE_TRADES);                  
         if(OrderMagicNumber()==slowMagicNumber && OrderSymbol()==Symbol())
         {
            pipExposure += MathAbs((OrderStopLoss()-OrderOpenPrice())/Point)/10;      
         }          
      }
    
    double totalExposure=0;  
    double pPoint=0;
    double totalDollarExposure=0;
    for (i=0;i<=ordTotal;i++)
      {      
         OrderSelect(i, SELECT_BY_POS, MODE_TRADES);   
         pPoint = MarketInfo(OrderSymbol(),MODE_POINT);
         if(OrderMagicNumber()== slowMagicNumber && pPoint!=0)
         {
            totalExposure += MathAbs(((OrderStopLoss()-OrderOpenPrice())/pPoint)/10);
            totalDollarExposure += (MathAbs(((OrderStopLoss()-OrderOpenPrice())/pPoint)/10))*MarketInfo(OrderSymbol(),MODE_TICKVALUE);
         }      
      }
    double equityExposure = (totalDollarExposure/AccountEquity())*100;    
      
   Comment("Symbol() PIP Exposure: "+DoubleToStr(pipExposure,1)+
           "\n"+"Total PIP Exposure: "+DoubleToStr(totalExposure,1)+
           "\n"+"Total Dollar Exposure: $"+DoubleToStr(totalDollarExposure,1)+
           "\n"+"% of Equity Exposure: "+DoubleToStr(equityExposure,1)+"%");   

}


void shortEntry()
{ 
   //  standard deviations range defined as externs
   double slowSTD=(sMultiple)*(iStdDev(NULL,tradingTimeFrame,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0));
   double fastSTD=(fMultiple)*(iStdDev(NULL,tradingTimeFrame,fastMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0)); //<--- you are never using fastSTD why do this djp
   
   string orderComment=TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS);
     
   //if(Close[0]>=slowMA30 && Close[0]>=slowMA60)
   //Comment(entryTF+"M Entry Closing Price: "+iClose(Symbol(),entryTF,1));
   
   //if(iClose(Symbol(),entryTF,1)>=slowMA30) Comment("30M entry is ready");
   //if(iClose(Symbol(),entryTF,1)>=slowMA60) Comment("60M entry is ready");
   
   //Comment("Short entry, 15min price needs to close above: "+slowMA30+" and "+slowMA60);
   if(iClose(Symbol(),entryTF,1)>=slowMA30 && iClose(Symbol(),entryTF,1)>=slowMA60) //if price closes above the MAs on entryTF(15), then enter
   {     
      if(!OpenOrders())      //<---- no orders open we can trade
      {  
         if(OpenOrdersAll()) //<---  check for hanging pending from a previous trade and close them
            Close_Orders();      
               
         PlaySound("alert.wav");
         
         Comment("Entering a SHORT position");
         
         bid = MarketInfo(Symbol(), MODE_BID);
         tp = NormalizeDouble(bid-(slowSTD*reward),digits);  //<---- leave outside loop so tp is the same for each order in stack
         sl = NormalizeDouble(bid+(slowSTD*risk),digits);  //<---- leave outside loop so sl is the same for each order in stack
         type = OP_SELL;
         
         for (int i = 0; i < maxSlowTrades; i++)
         {
            int ticket = OrderSend(Symbol(), type, lots, NormalizeDouble(bid,digits), 0, 0, 0, orderComment, slowMagicNumber,0,Green);
            if(ticket>0)
            {
               OrderSelect(ticket, SELECT_BY_TICKET);
               OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,Green);
            }
            if(!i)
               type = OP_SELLSTOP;
            bid -= DistanceApart * point;       
          }        
       }    
    }
}

void checkSLandTP()
{
int orderCnt=0;
   int openedOrders= OrdersTotal();
      for (int i=0;i<=openedOrders;i++)
      {
         OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
         if(OrderMagicNumber()==slowMagicNumber && OrderSymbol()==Symbol() && (OrderStopLoss()==0 || OrderTakeProfit()==0))
         {
            if(OrderType()==OP_SELL)
            {
               OrderClose(OrderTicket(),OrderLots(),Ask,3,Orange);
            }
            if(OrderType()==OP_BUY)
            {
               OrderClose(OrderTicket(),OrderLots(),Bid,3,Orange);
            }
         }
      }
}


void longEntry()
{
   // get 2 standard deviations range
   double slowSTD=(sMultiple)*(iStdDev(NULL,tradingTimeFrame,slowMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0));
  // double fastSTD=(fMultiple)*(iStdDev(NULL,tradingTimeFrame,fastMovingPeriod,0,MODE_SMA,PRICE_CLOSE,0));  //<--- you are never using fastSTD why do this djp
   
   string orderComment=TimeToStr(TimeCurrent(),TIME_DATE|TIME_SECONDS);
   
   //if(Close[0]<=slowMA30 && Close[0]<=slowMA60)
   //Comment(entryTF+"M Entry Closing Price: "+iClose(Symbol(),entryTF,1));
   
   Comment("Long entry, 15min price needs to close below: "+slowMA30+" and "+slowMA60);
  
   if(iClose(Symbol(),entryTF,1)<=slowMA30 && iClose(Symbol(),entryTF,1)<=slowMA60) //if price closes below the MAs on entryTF(15), then enter
   {
      if(!OpenOrders())      //<---- no buy orders open we can trade
      {  
         if(OpenOrdersAll()) //<---  check for hanging pending from last order
            Close_Orders();      
         
         PlaySound("alert.wav");
         
         Comment("Entering a LONG position");

         ask = MarketInfo(Symbol(), MODE_ASK);
         tp = NormalizeDouble(ask+(slowSTD*reward), digits);  //<---- leave outside loop so tp is the same for each order in stack
         sl = NormalizeDouble(ask-(slowSTD*risk), digits);  //<---- leave outside loop so sl is the same for each order in stack
         type = OP_BUY;
         
         for (int i = 0; i < maxSlowTrades; i++)
         {
             int ticket = OrderSend(Symbol(), type, lots, NormalizeDouble(ask,digits), 0, 0, 0, orderComment, slowMagicNumber,0,Green);
             if(ticket>0)
             {
                OrderSelect(ticket, SELECT_BY_TICKET);
                OrderModify(OrderTicket(),OrderOpenPrice(),sl,tp,0,Green);
             }
             if(!i)
                type = OP_BUYSTOP;
             ask += DistanceApart * point;                    
         }
      }
   }   
}

//<---- Close_Orders

bool Close_Orders()
{       
   for(int pos = OrdersTotal()-1; pos >= 0 ; pos--) 
   {
      if(OrderSelect(pos, SELECT_BY_POS)      
      &&  OrderMagicNumber()  == slowMagicNumber   //<---- this magic number
      &&  OrderSymbol()       == Symbol())         //<---- this symbol
      {
         if(IsMarket(OrderType()))  //<---- Open Orders, need use OrderClose()
         {
            double price;
            if(OrderType() == OP_BUY)
            {
               price = MarketInfo(Symbol(), MODE_BID);
            }
            else // if(OrderType() == OP_SELL)
            {
               price = MarketInfo(Symbol(), MODE_ASK);
            }
            if(OrderClose(OrderTicket(), OrderLots(), price, 3,Orange))
            {
               continue;
            }
            else
            {
               Print("Error in Close_Orders, Close");
               return(false);
            }
            
         }
         else  //<---- Pending orders need to use OrderDelete  You will need this in later versions of this EA
         {
            if(OrderDelete(OrderTicket()))
            {
               continue;
            }
            else
            {
               Print("Error in Close_Orders, Delete");
               return(false);
            }
         }
      }
   }
   return(true);
}

//<---- is_market                                                        

bool IsMarket(int orderType)
{
   bool result;
   
   switch (orderType)
   {
      case OP_BUY:
      case OP_SELL:
         result = true;
         break;
      default:
         result = false;
         break;
   }
   
   return (result);
}

//<---- Check for Open orders, not pending                          

bool OpenOrders()
{
    int ordercount=0;
    for(int pos = OrdersTotal()-1; pos >= 0 ; pos--) 
    {
       if(OrderSelect(pos, SELECT_BY_POS)                //<---- this order
       &&  OrderMagicNumber()  == slowMagicNumber        //<---- this magic number
       &&  OrderSymbol()       == Symbol())              //<---- this pair
       {
          if((OrderType() == OP_BUY)||(OrderType() == OP_SELL)) //<---- open orders only
          {             
             ordercount++;
          }
       }
    }        
    if(ordercount>0)
       return (true);
    else
       return (false);
}


//<---- OpenOrdersAll Open and Pendng

bool OpenOrdersAll()
{
    int ordercount=0;
    for(int pos = OrdersTotal()-1; pos >= 0 ; pos--) 
    {
       if(OrderSelect(pos, SELECT_BY_POS)               //<---- this order
       &&  OrderMagicNumber()  == slowMagicNumber       //<---- this magic number
       &&  OrderSymbol()       == Symbol())             //<---- this pair
       {     
          ordercount++;
       }
    }        
    if(ordercount>0)
       return (true);
    else
       return (false);
}

//<---- Check for trading hours, returns true                    

 bool TradingHours()
 { 
  if(OpenHour < CloseHour)
  {
    if(Hour() >= OpenHour)
     if(Hour() < CloseHour) 
       return (true);
  }
 else
  {
    if((Hour() >= OpenHour) && (Hour() < 24)) 
        return (true);
    if((Hour() >= 0) && (Hour() < CloseHour)) 
        return (true);
  } 
  return (false); 
}

int init()
  {
//----

   if(Stack > 0)   
      maxSlowTrades = Stack;
      
   point = MarketInfo(Symbol(), MODE_POINT);
   if(point == 0.001  ||  point == 0.00001)
	      point *= 10;
	      
	digits = MarketInfo(Symbol(), MODE_DIGITS);
	if(digits == 0)
	{	
	  Print("Failure MarketInfo MODE_DIGITS ");
	  return;
	}
	  	      

//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
{      

   checkSLandTP();
   reverseTrades = false; // <---- reset this on every entry set to true in stddev check
   
   if(AllowTradingHours)
   {
      if(TradingHours()) //<---- time to trade OK?  
      { 
         checkConditions();
      }
      else  
      {
         return(0);  
      }
   }    
   else
   {
     checkConditions();
   }
    
   checkExposure();
   
 /*  if(enableSTDcheck==true)   //<---- moved into checkconditions not sure why here?
   {
      checkSTD();
   }   */
   
   return(0);
}
//+------------------------------------------------------------------+